## net.sf.saxon.expr
Class CastExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.CastExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

    public final class CastExpression

extends UnaryExpression

Cast Expression: implements "cast as data-type ( expression )". It also allows an internal cast, which has the same semantics as a user-requested cast, but maps an empty sequence to an empty sequence.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`CastExpression(Expression source, AtomicType target, boolean allowEmpty)` Create a cast expression

Method Summary
`boolean` `allowsEmpty()` Ask whether the expression accepts an empty sequence as input (producing an empty sequence as output)
`static AtomicValue` `castStringToQName(CharSequence operand, AtomicType targetType, StaticContext env)` Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value.
`int` `computeCardinality()` Get the static cardinality of the expression
`int` `computeSpecialProperties()` Determine the special properties of this expression
`Expression` `copy()` Copy an expression.
`boolean` `equals(Object other)` Is this expression the same as another expression?
`Item` `evaluateItem(XPathContext context)` Evaluate the expression
`void` `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`ItemType` `getItemType(TypeHierarchy th)` Get the static type of the expression
`AtomicType` `getTargetPrimitiveType()` Get the primitive base type of the target type of the cast
`AtomicType` `getTargetType()` Get the target type (the result type)
`int` `hashCode()` get HashCode for comparing two expressions.
`static boolean` `isPossibleCast(int source, int target)` Determine whether casting from a source type to a target type is possible
`boolean` `isUpCast()` Ask whether this is a cast to a supertype of the original type
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` `simplify(ExpressionVisitor visitor)` Simplify the expression
`boolean` `targetIsDerived()` Ask whether the target type is a derived type (not a primitive type)
`String` `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`displayOperator, getBaseExpression, iterateSubExpressions, promote, replaceSubExpression`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CastExpression

    public CastExpression(Expression source,
                          AtomicType target,
                          boolean allowEmpty)

  Create a cast expression

  Parameters:
    `source` - expression giving the value to be converted
    `target` - the type to which the value is to be converted
    `allowEmpty` - true if the expression allows an empty sequence as input, producing an empty sequence as output. If false, an empty sequence is a type error.

Method Detail

### isPossibleCast

    public static boolean isPossibleCast(int source,
                                         int target)

  Determine whether casting from a source type to a target type is possible

  Parameters:
    `source` - a primitive type (one that has an entry in the casting table)
    `target` - another primitive type
  Returns:
    true if the entry in the casting table is either "Y" (casting always succeeds) or "M" (casting allowed but may fail for some values)

### getTargetPrimitiveType

    public AtomicType getTargetPrimitiveType()

  Get the primitive base type of the target type of the cast

  Returns:
    the primitive type of the target type

### getTargetType

    public AtomicType getTargetType()

  Get the target type (the result type)

  Returns:
    the target type

### allowsEmpty

    public boolean allowsEmpty()

  Ask whether the expression accepts an empty sequence as input (producing an empty sequence as output)

  Returns:
    true if an empty sequence is accepted

### targetIsDerived

    public boolean targetIsDerived()

  Ask whether the target type is a derived type (not a primitive type)

  Returns:
    true if the target type is a derived type

### isUpCast

    public boolean isUpCast()

  Ask whether this is a cast to a supertype of the original type

  Returns:
    true if this is an upcast. This means the value stays unchanged and only the type label changes

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify the expression

  Overrides:
    `simplify` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### computeCardinality

    public int computeCardinality()

  Get the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static type of the expression

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

  Overrides:
    `hashCode` in class `UnaryExpression`

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `UnaryExpression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Overrides:
    `explain` in class `UnaryExpression`
  Parameters:
    `out` - the expression presenter used to display the structure

### castStringToQName

    public static AtomicValue castStringToQName(CharSequence operand,
                                                AtomicType targetType,
                                                StaticContext env)
                                         throws XPathException

  Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value. This can only happen at compile time

  Parameters:
    `operand` - the value to be converted
    `targetType` - the type to which it is to be converted
    `env` - the static context
  Returns:
    the QName or NOTATION value that results from casting the string to a QName. This will either be a QNameValue or a derived AtomicValue derived from QName or NOTATION
  Throws:
    `XPathException`

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.